'''
Created on 20. feb. 2011

@author: kimg

NOTE: open to SQLinjection attacks
'''
import sqlite3,Constants,sys

class DBManager():
    
    def __init__(self):
        self.conn = sqlite3.connect(Constants.PATH_DB+"database.db")
        self.curs = self.conn.cursor()
        
        
    
    def initTable(self):
        self.createNewsCategoryTable()
        self.createNewsTable()
    
    def createNewsTable(self):
        try:
            self.curs.execute('''create table news
              (news_id integer primary key, date string,
                    time string, path text, name text, source text, source_link text, language text)''')
        except Exception, err:
                sys.stderr.write('FAILED: %s\n' % str(err))
                
    def createNewsCategoryTable(self):
        try:
            self.curs.execute('''create table news_category
              (news_id integer, name text, category text)''')
        except Exception, err:
                sys.stderr.write('FAILED: %s\n' % str(err))
                
    
    def addNews(self,date,time,path,name,source,source_link,language):
        try:
            h = path.split("\\")
            path=""
            for p in h: path+=p+" "
            self.curs.execute("insert into news values\
                    (NULL,'"+date+"','"+time+"','"+path+"','"+name+"','"+source+"','"+source_link+"','"+language+"')")
            self.conn.commit()
        except Exception, err:
            sys.stderr.write('ERROR: %s\n' % str(err))
            
    def addNewsCategory(self,name,category):
        try:
            id = None
            self.curs.execute("select news_id from news where name ='"+name+"'")
            for r in self.curs:
                id=int(r[0])
            self.curs.execute("insert into news_category values\
                    ("+str(id)+",'"+name+"','"+category+"')")
            self.conn.commit()
        except Exception, err:
            sys.stderr.write('ERROR: %s\n' % str(err))


    
    def getNewsPathAll(self):
        news = []
        self.curs.execute("select path, name from news")
        for row in self.curs:
            p = row[0].split()
            path=""
            for t in p: path+=t+"\\"
            news.append(path+row[1])
        return news
    
    def getNewsPathLanugage(self,language):
        news = []
        self.curs.execute("select path, name from news where language='"+language+"'")
        for row in self.curs:
            p = row[0].split()
            path=""
            for t in p: path+=t+"\\"
            news.append(path+row[1])
        return news
    
    def getNewsPathLanugageTicker(self,language,ticker):
        news = []
        curs2 = self.conn.cursor()
        self.curs.execute("select news_id from news_category where category='"+ticker+"'")
        for row in self.curs:
            curs2.execute("select path, name, language from news where news_id="+str(row[0])+"" )
            for row2 in curs2:
                #print row2[2]
                if row2[2]==language:
                    p = row2[0].split()
                    path=""
                    for t in p: path+=t+"\\"
                    news.append(path+row2[1])        
        return news
    
    def getDateFromName(self,title):
        self.curs.execute("select date from news where name='"+title+"'")
        for row in self.curs:
            return str(row[0])
        
    def getTimeFromName(self,title):
        self.curs.execute("select time from news where name='"+title+"'")
        for row in self.curs:
            return str(row[0])
    
    def getCategoryFromName(self,title):
        self.curs.execute("select category from news_category where name='"+title+"'")
        for row in self.curs:
            return row[0]
    
    def getSourceFromName(self,title):
        self.curs.execute("select source from news where name='"+title+"'")
        for row in self.curs:
            return row[0]
         
if __name__=="__main__":
    #print "Create DB"
    db = DBManager()
    paths = db.getNewsPathLanugageTicker("no", "BWO")
    for p in paths: print p