'''
Created on 1. apr. 2011

@author: kimg
'''


import LocalDataConnector, Constants,InvertedIndex
import FSMetric
import nltk
import TextPreprocessingTools, NewsArticleParseHelpers,DBManager


class DocData(object):
    
    def __init__(self,path,id=None,category=None):
        self.category=category  #sentiment #TODO: rename
        self.predicted_category=None
        self.ticker=""          #About comapny 
        self.id=id
        self.path=path
        self.name=""
        self.date=None
        self.time=None
        self.text=""
        self.tokens=[]
        self.invertedIndex=InvertedIndex.InvertedIndex()     
        self.doc_rep=[]
        self.__load()           #load doc from file
    
    def __load(self):
        dc = LocalDataConnector.LocalDataConnector()
        self.text = NewsArticleParseHelpers.getText(dc.getNewsAllTextFromFilename(self.path))
        sp = self.path.split("\\")
        self.ticker=sp[-2]
        self.name=sp[-1]
        db=DBManager.DBManager()
        self.date=db.getDateFromName(self.name)
        self.time=db.getTimeFromName(self.name)
        

    #def getDocRep(self):