'''
Created on 19. feb. 2011

@author: kimg
'''

import nltk,string

def ASCIItoSymbolsToken(token):
    token2=[]
    go=True
    for i in xrange(len(token)):
        
        if go == False and token[i]==";":go=True
        
        elif go == True:
            if token[i] == "&":
                if len(token)>i+3 and token[i+3]==";":
                    token2.append( chr(int(token[i+2])) )
                    go=False
                    
            elif token[i] == "#" and i>0:
                if token[i-1][len(token[i-1])-1]=="&":
                    if len(token)>i+2 and token[i+2]==";":
                        token2.pop(len(token2)-1)
                        token2.append(token[i-1][:len(token[i-1])-1])
                        token2.append(chr(int(token[i+1])))
                        go=False
            
            else:   token2.append(token[i])
    return token2

def ASCIItoSymbolsText(doc):
    text = ""
    for line in doc.split("\n"):
        token2=ASCIItoSymbolsToken(nltk.word_tokenize(line))
        for t in token2:
            text+=t+" "
        text+="\n"
    return text
    
    
def stopwordremoval(tokens,lang="norwegian"):
    return [t for t in tokens if all(c in string.letters for c in t) and t not in nltk.corpus.stopwords.words(lang)]
    
def stemmer(tokens,lang="norwegian"):
    stemmer = nltk.SnowballStemmer(lang)
    return [stemmer.stem(t) for t in tokens]
    
if __name__ == "__main__":
    print ASCIItoSymbolsText("test &#040;&#096;Rocksource&#096;&#041; test\ntest2")