


import ClassifierOne,DocPrepEngine

class ClassifierTwo():
    
    def __init__(self):
        self.cPos = ClassifierOne.ClassifierOne()
        self.cNut = ClassifierOne.ClassifierOne()
        self.cNeg = ClassifierOne.ClassifierOne() 
        
        self.vocabularyLocalPositive=[]
        self.vocabularyLocalNeutral=[]
        self.vocabularyLocalNegative=[]
        
        self.docPrepEninge = DocPrepEngine.DocPrepEngine()
    
    def train(self,ypos,xpos,ynut,xnut,yneg,xneg, option='-t 2'):
        #print "Vocabulary size c2, pos, neg, nut: ",len(self.vocabularyLocalPositive),len(self.vocabularyLocalNeutral),len(self.vocabularyLocalNegative)
        #self.docPrepEninge.documentRepresentationsAll(xpos, self.vocabularyLocalPositive)
        #self.docPrepEninge.documentRepresentationsAll(xnut, self.vocabularyLocalNeutral)
        #self.docPrepEninge.documentRepresentationsAll(xneg, self.vocabularyLocalNegative)
        self.cPos.train(ypos, xpos,option)
        self.cNut.train(ynut, xnut,option)
        self.cNeg.train(yneg, xneg,option)
        
    def test(self,y,x):
        self.docPrepEninge.documentRepresentationsAll(x, self.vocabularyLocalPositive)
        p_label_pos, p_acc, p_val_pos = self.cPos.test(y,x)
        
        self.docPrepEninge.documentRepresentationsAll(x, self.vocabularyLocalNeutral)            
        p_label_nut, p_acc, p_val_nut = self.cNut.test(y,x)
        
        self.docPrepEninge.documentRepresentationsAll(x, self.vocabularyLocalNegative)           
        p_label_neg, p_acc, p_val_neg = self.cNeg.test(y,x)
        
        return (p_label_pos,p_label_nut,p_label_neg,p_val_pos,p_val_nut,p_val_neg)
