

"""
TODO: Better class name
"""

import FSMetric
import Constants
import DocPrepEngine
from sets import Set

class DocumentClusterRefining():
    
    def __init__(self):
        
        pass
    
    
    #TODO: remove docs in inverted index for method 2
    def refining(self,docs,method=1,nr=100):
        #############
        #Training set clustering refining 
        pos,neg,nut=[],[],[]
        for doc in docs:
            if doc.category==Constants.SENTIMENT_NEG: neg.append(doc)
            elif doc.category==Constants.SENTIMENT_NUT: nut.append(doc)
            elif doc.category==Constants.SENTIMENT_POS: pos.append(doc)        
        
        print "start training set cluster refining"
        clusters=[pos,nut,neg]
        print len(clusters[0]),len(clusters[1]),len(clusters[2])
        stop=False
        count=0
        centroids=[]
        clustersHolder=[]
        docPrep=DocPrepEngine.DocPrepEngine()
        #docs=[]
        #for cluster in clusters: docs+=cluster
        #vocab=docPrep.featureReductionOnTermScores(docs, int(len(clusters[0][0].invertedIndex.index)*0.2))
        #print "cluster vocab len: ",len(vocab)," Total term: ",len(clusters[0][0].invertedIndex.index)
        #Cluster centroids and inint cluster holder
        for cluster in clusters:
            docPrep.documentRepresentationsAll(cluster)
            centroids.append(self.centriod(cluster))
            clustersHolder.append([])
            
        
        
        #for docs in clusters: 
        while not stop and count < nr:
            count+=1       
            #print count
            
            #1-For each cluster
            for i in xrange(len(clusters)):
                #2-Iterate over clusters documents
                for doc in clusters[i]:
                    #if doc.doc_rep==[]: doc.docRep()
                    max1,index=FSMetric.sim_cosin(doc.doc_rep, centroids[i]),i
                    #3-Compare against every clusters centroid
                    for j in xrange(len(centroids)):
                        if j!=i:
                            holder=FSMetric.sim_cosin(doc.doc_rep, centroids[j])
                            #if holder > 0.0: print holder
                            if holder>max1:
                                if method==1:
                                    if j==i or j==i or j==1 or i==1:
                                        max1=holder
                                        index=j
                                else:
                                    max1=holder
                                    index=j
                    #4-Add doc to closest cluster centroid
                    if method==2:
                        if index==0 and doc.category != Constants.SENTIMENT_NEG \
                        or index==2 and doc.category != Constants.SENTIMENT_POS \
                        or index==1: 
                            clustersHolder[index].append(doc)
                    else:
                        clustersHolder[index].append(doc)
                    #print max1
            clusters=clustersHolder
            
            ncentroids=[]
            clustersHolder=[]
            for cluster in clusters:
                ncentroids.append(self.centriod(cluster))
                clustersHolder.append([])
            stop=self.__stopCond(ncentroids, centroids)
            centroids=ncentroids
            
        print len(clusters[0]),len(clusters[1]),len(clusters[2])
        print "end training set cluster refining"
        pospos,posneg,posnut,nutpos,nutneg,nutnut,negpos,negneg,negnut=0,0,0,0,0,0,0,0,0
        for d in clusters[0]:
            if d.category==Constants.SENTIMENT_POS:
                pospos+=1
            elif d.category==Constants.SENTIMENT_NEG:
                posneg+=1
            elif d.category==Constants.SENTIMENT_NUT:
                posnut+=1
            d.category=Constants.SENTIMENT_POS
        for d in clusters[1]:
            if d.category==Constants.SENTIMENT_POS:
                nutpos+=1
            elif d.category==Constants.SENTIMENT_NEG:
                nutneg+=1
            elif d.category==Constants.SENTIMENT_NUT:
                nutnut+=1
            d.category=Constants.SENTIMENT_NUT
        for d in clusters[2]:
            if d.category==Constants.SENTIMENT_POS:
                negpos+=1
            elif d.category==Constants.SENTIMENT_NEG:
                negneg+=1
            elif d.category==Constants.SENTIMENT_NUT:
                negnut+=1
            d.category=Constants.SENTIMENT_NEG
            
        print "new pos: ("+str(pospos)+","+str(posnut)+","+str(posneg)+")"
        print "new nut: ("+str(nutpos)+","+str(nutnut)+","+str(nutneg)+")"
        print "new neg: ("+str(negpos)+","+str(negnut)+","+str(negneg)+")"  
          
        #docs=clusters[0]+clusters[1]+clusters[2]
        for doc in docs: 
            if doc not in clusters[0] and doc not in clusters[1] and doc not in clusters[2]:
                doc.invertedIndex.removeDoc(doc.id)
                docs.remove(doc)
        return docs
        
    
    #def vocab(self,cpos,cneg,size=0):   
    
    def refining3(self,docs,manualDocs):
        newClusters,centroids=[],[]
        
        docPrep=DocPrepEngine.DocPrepEngine()
        pos,nut,neg=docPrep.divideDocsInPosNeutNeg(docs)
        manualClusters=[pos,neg]
        
        for cluster in manualClusters:
            docPrep.documentRepresentationsAll(cluster)
            centroids.append(self.centriod(cluster))
            newClusters.append([])
        print docs[0].doc_rep
        print len(centroids[0])
        
        for doc in docs:
            max1,index=FSMetric.sim_cosin(doc.doc_rep, centroids[0]),0
            for i in xrange(len(centroids)):
                #if i == 0: 
                holder=FSMetric.sim_cosin(doc.doc_rep, centroids[i])
                if holder > max1:
                    max1=holder
                    index=i
                #print holder
                #if holder==0.0: print doc.doc_rep
            #print "-----"
            doc.category = manualClusters[index][0].category
            newClusters[index].append(doc)
        print "refininf lengths: ",len(newClusters[0]),len(newClusters[1])
        min1=min(len(newClusters[0]),len(newClusters[1]))
        #print min1
        print "centroid sim: ",FSMetric.sim_cosin(centroids[0], centroids[1])
        docs=newClusters[0][:min1]+newClusters[1][:min1]
        #print len(docs)
        return docs
        
       
    def refining2(self,docs):
        thresh=4.7
        pos,neg,nut=[],[],[]
        for doc in docs:
            if doc.category==Constants.SENTIMENT_NEG: neg.append(doc)
            elif doc.category==Constants.SENTIMENT_NUT: nut.append(doc)
            elif doc.category==Constants.SENTIMENT_POS: pos.append(doc) 
        
        print "docs len before doc select pos,nut,neg", len(pos),len(nut),len(neg)
        negnut=neg+nut
        posnut=pos+nut
        negpos=neg+pos
        
        spos=FSMetric.chiSquareTopFeaturesThersh(pos, negnut,thresh)
        sneg=FSMetric.chiSquareTopFeaturesThersh(neg, posnut,thresh)
        snut=FSMetric.chiSquareTopFeaturesThersh(nut, negpos,thresh)
        
        dpos,dnut,dneg={},{},{}
        
        for x in spos: dpos[x[0]]=x[1]
        for x in sneg: dneg[x[0]]=x[1]
        for x in snut: dnut[x[0]]=x[1]
        
        
                    
        
        pos,neg,nut=[],[],[]
        for doc in docs:
            if doc.category==Constants.SENTIMENT_NEG: neg.append(doc)
            elif doc.category==Constants.SENTIMENT_NUT: nut.append(doc)
            elif doc.category==Constants.SENTIMENT_POS: pos.append(doc)
        print "len pos,nut,neg: ",len(pos),len(nut),len(neg)
        return docs
        
    
  
    def __stopCond(self,centroidsBefore, centroidsAfter):
        sim=0.0
        
        for i in xrange(len(centroidsBefore)):
            sim+=(1.0-FSMetric.sim_cosin(centroidsBefore[i], centroidsAfter[i]))
        print sim
        if sim<0.01: return True
        else: return False
  
    
    def centriod(self,cluster):
        centroid=[]
        for doc in cluster:
            if centroid==[]:
                for i in doc.doc_rep:
                    centroid.append(i)
            else:
                for i in xrange(len(doc.doc_rep)):
                    centroid[i]+=doc.doc_rep[i]
        #print centroid
        for i in xrange(len(centroid)):
            centroid[i]=centroid[i]/len(cluster)        
        return centroid





    



